<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
  <validation-provider :rules="validationRules" v-slot="{ errors }">
    <!--    transition-show="flip-up"-->

    <q-select
      ref="select"
      :label="label"
      :filled="mainDesign ==='filled'"
      :outlined="mainDesign ==='outlined'"
      :standout="mainDesign ==='standout'"
      :borderless="mainDesign ==='borderless'"
      :standard="mainDesign ==='standard'"
      dense
      :clearable="clearable"
      clear-icon="la la-times"
      v-bind:value="value"
      v-on:input="change"
      :readonly="readonly"
      :disable="disabled"
      :loading="loading"
      :bottom-slots="error"
      square
      :error="errors.length !== 0"
      :error-message="errors[0]"

      :options="options"
      :option-value="optionValue"
      :option-label="optionLabel"
      :options-dense="optionsDense"

      :multiple="multiple"
      :use-chips="chips"
      :use-input="usingInput"
      v-on:focusout.native="blur"
      v-on:[filterEvent]="filterFn"
      :hide-dropdown-icon="mainDesign ==='borderless'"
      :hide-bottom-space="hideBottomSpace"
      :placeholder="placeholder"
      :dropdown-icon="mDropDownIcon"
      @new-value="createValue"
    >
      <template v-slot:label>
        <slot name="label">
          {{label}} <span v-if="isRequire">*</span>
        </slot>
      </template>
      <template v-slot:before>
        <slot name="mBefore"/>
      </template>

      <template v-show="usingInput" v-slot:no-option>
        <q-item>
          <q-item-section class="text-grey">
            Aucun résultat
          </q-item-section>
        </q-item>
        <q-btn
          v-if="onCreate"
          flat stretch
          class="full-width"
          align="left"
          color="white"
          text-color="primary"
          no-caps
          size="md"
          label="Créer & Modifier"
          @click="onCreate"
        />
      </template>

      <template v-slot:[dynamicSlotName]="slotProps">
        <slot name="mOption" :scope="slotProps"/>
      </template>

      <template v-slot:[dynamicSlotSelectedItem]="scope">
        <slot name="mSelectedItem" :scope="scope"/>
      </template>

      <template v-slot:after-options>
        <q-btn
          v-if="onCreate"
          flat stretch
          class="full-width"
          align="left"
          color="white"
          text-color="primary"
          no-caps
          size="md"
          :label="addRowBtnLabel"
          @click="onCreate"
        />
      </template>

    </q-select>
  </validation-provider>

</template>
<script>
import {extend, ValidationProvider} from 'vee-validate';
import {required} from 'vee-validate/dist/rules';

extend('required', {
  ...required,
  message: `Ce champ est requis`
});

export default {
  name: 'MSelect',
  model: {
    prop: 'value',
    event: 'input',
  },
  props: {
    labelWidth: Number,
    value: {
      type: [Object, Array, Number, String],
      default: '',
    },
    error: {
      type: Boolean,
      default: false,
    },
    readonly: {
      type: Boolean,
      default: false,
    },
    clearable: {
      type: Boolean,
      default: false,
    },
    loading: {
      type: Boolean,
      default: false,
    },
    disabled: {
      type: Boolean,
      default: false,
    },
    optionsDense: {
      type: Boolean,
      default: false,
    },
    hideDropDown: {
      type: Boolean,
      default: false,
    },
    mDropDownIcon: {
      type: String,
      default: 'la la-angle-down'
    },
    noBorder: {
      type: Boolean,
      default: false,
    },
    hideBottomSpace: {
      type: Boolean,
      default: false,
    },
    errorMessage: String,
    placeholder: String,
    label: String,
    options: Array,
    chips: {
      type: Boolean,
      default: false,
    },
    validationRules: {
      type: [String],
      default: ''
    },
    multiple: {
      type: Boolean,
      default: false,
    },
    usingInput: {
      type: Boolean,
      default: false,
    },
    outlined: {
      type: Boolean,
      default: true,
    },
    customOption: {
      type: Boolean,
      default: false,
    },
    mainDesign: {
      type: String,
      default: 'borderless',
    },
    optionValue: [String, Function],
    optionLabel: [String, Function], //
    dynamicSlotSelectedItem: {
      type: String,
      default: '',
    },
    onCreate: {
      type: Function,
      default: null,
    },
    addRowBtnLabel: {
      type: String,
      default: 'Ajouter une ligne',
    },
    filterFunction: {
      type: Function,
      default: null,
    },
    filterAttributes: {
      type: Array,
      default: null,
    },
    filterStoreLink: {
      type: String,
      default: null,
    },
    filterPrecision: {
      type: Boolean,
      default: false,
    },
  },

  data: () => {
    return {
      filterEvent: null,
      dynamicSlotName: null,
    }
  },

  components: {ValidationProvider},

  methods: {
    change(val) {
      this.$emit('input', val)
    },
    blur(e) {
      this.$emit('m-blur', e)
    },
    filterFn(val, update, abort) {
      if (this.filterFunction) {
        return this.filterFunction(val, update, abort)
      }

      if (this.filterAttributes && this.filterStoreLink && val.length > 1) {
        update(async () => {
          const filter = this.buildFilter(this.filterAttributes, val, this.filterPrecision)
          await this.$store.dispatch(this.filterStoreLink, {filter})
        })
      } else {
        update()
      }
    },


    buildFilter(attributes, search, isPrecise = false) {
      return {
        "type": "operator", "operand": "or", "value": [
          ...attributes.map(x => ({
            "type": "condition",
            "field": x,
            "value": search,
            "operand": isPrecise ? "eq" : "contain"
          }))
        ]
      }
    },

    createValue(val, done) {
      this.$emit('m-new-value', val, done)
    }
  },

  computed:{
    isRequire(){
      const check = (val) => /required/.test(val);
      return Array.isArray(this.validationRules) ?
        this.validationRules.some(check) : check(this.validationRules)
    }
  },

  mounted() {
    if (this.usingInput)
      this.filterEvent = 'filter'
    if (this.customOption)
      this.dynamicSlotName = 'option'
  },
}
</script>

<style lang="sass">
.MSelect
  & .q-field-label
    color: #666666
</style>
